/******************************************************************************
* NCSimDefs.h - basic defs goes here.					      *
*******************************************************************************
* (C) Gershon Elber					                      *
*******************************************************************************
* Written by Gershon Elber, Dec 2006.					      *
******************************************************************************/

#ifndef NCSIM_DEFS
#define NCSIM_DEFS

#include <stdio.h>

#define NCSIM_VERSION		"1.1, " __DATE__ "\n(C) Copyright Gershon Elber 2006-12"

#define NCSIM_PROGRAM_NUMBER	"1.1.20121022"

#define NCSIM_WEBSITE		"http://www.cs.technion.ac.il/~gershon/NCSim"


#define NCSIM_INVALID_PTR	((VoidPtr) -1)
#define NCSIM_INVALID_INT	-2147483646
#define NCSIM_INVALID_REAL	(-HUGE_VAL * 0.301060)

#define NCSIM_TOOL_HEIGHT_DIAM	10              /* Diameter to height ratio. */

#define NCSIM_DEFAULT_PLLN_OPTI_FINENESS	0.001

#define NCSIM_MIN_ZBUFFER_SIZE	100
#define NCSIM_MAX_ZBUFFER_SIZE	10000
#define NCSIM_DEF_ZBUFFER_SIZE	1000

#define NCSIM_COLOR_INFO	wxColour(0, 0, 130)
#define NCSIM_COLOR_WARN	wxColour(100, 100, 0)
#define NCSIM_COLOR_ERROR	wxColour(160, 0, 0)

#define NCSIM_COLOR_NORMAL	wxColour(0, 0, 0)
#define NCSIM_COLOR_HIGHLIGHT	wxColour(200, 0, 0)

#ifdef NCSIM_DEBUG_FUNC_TRACE
#define NCSIM_DEBUG_FUNC_ENTRY	fprintf(stderr, \
				    "Enter function at line %d, file %s\n", \
				    __LINE__, __FILE__);
#define NCSIM_DEBUG_IN_FUNC	fprintf(stderr, \
				    "Inside function at line %d, file %s\n", \
				    __LINE__, __FILE__);
#define NCSIM_DEBUG_FUNC_EXIT	fprintf(stderr, \
				    "Exit function at line %d, file %s\n", \
				    __LINE__, __FILE__);
#else
#define NCSIM_DEBUG_FUNC_ENTRY
#define NCSIM_DEBUG_IN_FUNC
#define NCSIM_DEBUG_FUNC_EXIT
#endif /* MOS_DEBUG_FUNC_TRACE */

#define NCSIM_MM2INCHES(x)	((x) / 25.4)
#define NCSIM_INCHES2MM(x)	((x) * 25.4)

#define NCSIM_NAME_FROM_PATH(FName, FullPath) { \
    const char *q; \
    if ((FName = strrchr(FullPath, '/')) != NULL || \
	(FName = strrchr(FullPath, '\\')) != NULL || \
	(FName = strrchr(FullPath, ':')) != NULL) { \
        /* Might have mixed '\\' and '/'. */ \
        if ((q = strrchr(FName, '\\')) != NULL && FName != q) \
	    FName = q; \
	FName++; \
    } \
    else \
        FName = FullPath; \
}


typedef enum {
    NCSIM_LOG_INFO,
    NCSIM_LOG_WARN,
    NCSIM_LOG_ERROR
} NCSimLogStyleType;

typedef enum {
    NCSIM_OBJ_GEN,

    NCSIM_OBJ_TOOL,
    NCSIM_OBJ_STOCK,
    NCSIM_OBJ_PART
} NCSimObjectType;

typedef enum {
    NCSIM_UNIT_FIRST = 1,

    NCSIM_UNIT_MM = NCSIM_UNIT_FIRST,
    NCSIM_UNIT_INCHES,

    NCSIM_UNIT_LAST
} NCSimUnitsType;

#endif /* NCSIM_DEFS */
